
/*
 * Copyright 2011-2022 Cuberite Contributors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#pragma once

#include "AggressiveMonster.h"





class cGhast:
	public cAggressiveMonster
{
	using Super = cAggressiveMonster;

public:

	cGhast();

	CLASS_PROTODEF(cGhast)

	bool IsCharging(void) const { return m_IsCharging; }

private:

	virtual bool Attack(std::chrono::milliseconds a_Dt) override;
	virtual bool DoTakeDamage(TakeDamageInfo & a_TDI) override;
	virtual void GetDrops(cItems & a_Drops, cEntity * a_Killer = nullptr) override;
	virtual bool IsNetherNative(void) override { return true; }
	virtual void Tick(std::chrono::milliseconds a_Dt, cChunk & a_Chunk) override;

	/** Specifies whether or not the ghast has started shooting a fireball. */
	bool m_IsCharging;

	/** Number of ticks until the ghast tries to fly to another position. */
	int m_FlightCooldown;

	/** Number of ticks until a projectile is created.
	Only used while m_IsCharging is true. */
	int m_TicksUntilShot;
} ;
